<?php

/**
 * Trait for parameter aware component modifiers.
 */
trait ParameterAwareEntityTemplateComponentModifierTrait {

  /**
   * The parameters.
   * @var array
   */
  protected $parameters = [];

  /**
   * Set the parameters.
   *
   * @param array $parameters
   *    The parameters.
   *
   * @return $this
   *
   * @see \ParameterAwareEntityTemplateComponentModifierInterface::setParameters()
   */
  public function setParameters(array $parameters) : \ParameterAwareEntityTemplateComponentModifierInterface {
    $this->parameters = $parameters;
    return $this;
  }

}
